import java.awt.geom.Ellipse2D;

/**
 * Zeichnet eine Ellipse auf die Leinwand.
 * 
 * @author Bernd Gramlich
 * @version 2011-02-15
 */
public class Ellipse
{
    // Attribute
    private int positionX;
    private int positionY;
    private int breite;
    private int hoehe;    
    private String farbe;
    private boolean sichtbar;

    /**
     * Konstruktor der Klasse Ellipse.
     * Erzeugt eine neue Ellipse in Standardgre und Standardfarbe.
     */
    public Ellipse ()
    {
        hoehe    = 20;
        breite   = 30;
        farbe    = "rot";
        sichtbar = false;
    }
    
	/**
	 * Mache diese Ellipse sichtbar.
	 */
	public void macheSichtbar ()
	{
		sichtbar = true;
		zeichne ();
	}

	/**
	 * Mache diese Ellipse unsichtbar.
	 */
	public void macheUnsichtbar ()
	{
		loesche ();
		sichtbar = false;
	}
	
    /**
	 * ndere die Hhe dieser Ellipse.
	 */
	public void setzeHoehe (int neueHoehe)
	{
		hoehe = neueHoehe;
		zeichne ();
	}
	
	/**
	 * ndere die Breite dieser Ellipse.
	 */
	public void setzeBreite (int neueBreite)
	{
		breite = neueBreite;
		zeichne ();
	}
		
	/**
	 * ndere die Farbe dieser Ellipse in 'neueFarbe'. Gltige Angaben sind
	 * "rot", "gelb", "blau", "grn", "lila", "schwarz", "wei", "grau"
	 * "orange", "pink" und "trkis".
	 */
	public void setzeFarbe (String neueFarbe)
	{
		farbe = neueFarbe;
		zeichne ();
	}
	
	/**
	 * ndere die Position dieser Ellipse.
	 */
	public void setzePosition (int neuePositionX, int neuePositionY)
	{
		positionX = neuePositionX;
		positionY = neuePositionY;
		zeichne ();
	}
		
	/**
	 * Zeichne diese Ellipse auf die Leinwand.
	 */
	private void zeichne ()
	{
		if (sichtbar)
		{
			Leinwand leinwand = Leinwand.gibLeinwand ();
			leinwand.zeichne (this, farbe, new Ellipse2D.Double (positionX,
					positionY, breite, hoehe));
			leinwand.warte (10);
		}
	}

	/**
	 * Lsche diese Ellipse von der Leinwand.
	 */
	private void loesche ()
	{
		if (sichtbar) {
			Leinwand leinwand = Leinwand.gibLeinwand ();
			leinwand.entferne (this);
		}
	}
}
